IMPLEMENTATION MODULE mMoire;

IMPORT GEMVDIbase;
FROM VDIAttribs  IMPORT SetWritingMode,SetFillInteriorStyle,SetFillColour;
FROM AESGraphics IMPORT GrafMouse;
FROM VDIOutputs  IMPORT PolyLine,FillRectangle;
FROM AESEvents   IMPORT EventButton;

(*------------------------------------------------------------------------*)

PROCEDURE Fill( handle : INTEGER;
                  clip : GEMVDIbase.PxyArrayType;
                   col : INTEGER);
   VAR i : INTEGER;
   BEGIN
      GrafMouse(256,NIL);                  (* OFF *)
      i := SetFillInteriorStyle(handle,1); (* massiv *)
      i := SetFillColour(handle,col);      (* s/w *)
      i := SetWritingMode(handle,1);       (* write *)
      FillRectangle(handle,clip);          (* lscht *)
      GrafMouse(257,NIL);                  (* ON *)
END Fill;

(*------------------------------------------------------------------------*)

PROCEDURE DoMoire(rec : GEMVDIbase.PxyArrayType;
               handle : INTEGER;
                  col : INTEGER);

   VAR x   : INTEGER;
       i   : INTEGER;
       work: GEMVDIbase.PxyArrayType;

   BEGIN
      GrafMouse(256,NIL);                          (* OFF *)
      work[0] := rec[0]; work[2] := rec[0]+rec[2]; (* Eckpunkte *)
      work[1] := rec[1]; work[3] := rec[1]+rec[3];
      Fill(handle,work,col);                       (* Hintergrund *)
      i := SetWritingMode(handle,3);               (* XOR *)
      work[1] := rec[1]; work[3] := rec[3] + rec[1];
      FOR x:=0 TO rec[2] DO
         work[0] := rec[0] + x;
         work[2] := rec[0] + rec[2] - x;
         PolyLine(handle,2,work);
      END; (* FOR *)
      FOR x:=0 TO rec[3] DO
         work[1] := rec[1] + x;
         work[3] := rec[1] + rec[3] - x;
         PolyLine(handle,2,work);
      END; (* FOR *)
      i := EventButton(1,1,1,i,i,i,i);
      GrafMouse(257,NIL);
   END DoMoire;

END mMoire.
